hdu 5317 RGCDQ(dp)

RGCDQ

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 2618    Accepted Submission(s): 1040


Problem Description
Mr. Hdu is interested in Greatest Common Divisor (GCD). He wants to find more and more interesting things about GCD. Today He comes up with Range Greatest Common Divisor Query (RGCDQ). What’s RGCDQ? Please let me explain it to you gradually. For a positive integer x, F(x) indicates the number of kind of prime factor of x. For example F(2)=1. F(10)=2, because 10=2*5. F(12)=2, because 12=2*2*3, there are two kinds of prime factor. For each query, we will get an interval [L, R], Hdu wants to know  maxGCD(F(i),F(j))  (Li<jR)
 

Input
There are multiple queries. In the first line of the input file there is an integer T indicates the number of queries.
In the next T lines, each line contains L, R which is mentioned above.

All input items are integers.
1<= T <= 1000000
2<=L < R<=1000000
 

Output
For each query,output the answer in a single line. 
See the sample for more details.
 

Sample Input
 
  
2 2 3 3 5
 

Sample Output
 
  
1 1

solution:

首先我们对于每一个数求出含有质数因子的个数,由于R<=1e6,2*3*5*7*11*13*17*19>=1e6,那么我们可以知道对于x<=1e6,x含有的最大的质数因子的个数是7,那么我们令dp[i][j]代表1~i中质数因子个数为j的个数,那么对于[L,R],我们只需要求dp[R][j]-dp[L-1][j](1<=j<=7),然后再进行求解

#include<cstdio>
#include<algorithm>
using namespace std;
const int maxn = 1e6+20;
int dp[maxn][8], f[maxn];
int sb[8];
int main()
{
    for (int i = 2; i < maxn;i++)
        if (f[i] == 0)
        {
        for (int j =i; j < maxn; j += i)
            f[j]++;
        }
    for (int i = 2; i < maxn; i++)
    {
        for (int j = 1; j < 8; j++)
            dp[i][j] = dp[i - 1][j];
        dp[i][f[i]]++;
    }
    int t,l,r;
    scanf("%d", &t);
    while (t--)
    {
        scanf("%d%d", &l, &r);
        int ans = 1;
        for (int i = 1; i < 8; i++)
        {
            sb[i] = dp[r][i] - dp[l - 1][i];
            if (sb[i]>1)
                ans = max(ans, i);
        }
        if (sb[2]+sb[4]+sb[6]>1)
            ans = max(ans, 2);
        if (sb[3] && sb[6])
            ans = max(ans, 3);
        printf("%d\n", ans);
    }
    return 0;
}


猜你喜欢

转载自blog.csdn.net/qq_22522375/article/details/51628289